<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { PartnersQuotesCarousel as QuotesCarousel } from '~/components/partners/quotes-carousel/index.vue';
import { GetStartedResources } from '~/components/get-started/index';
import {
  CTA as CallToAction,
  Benefits,
  FreeTrialCTA,
  NextStep,
  Hero,
} from '~/components/common/index';
import {
  FeaturedPartners,
  PartnersShowcase,
  PartnersCopyBlock as TopicsCopyBlock,
} from '~/components/partners/index';
import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  components: {
    CallToAction,
    FeaturedPartners,
    Benefits,
    FreeTrialCTA,
    Hero,
    QuotesCarousel,
    TopicsCopyBlock,
    GetStartedResources,
    NextStep,
    PartnersShowcase,
  },
  nuxtI18n: false,
  // eslint-disable-next-line
  async asyncData({ $content, params, error }: any) {
    try {
      const partner = await $content(`partners/benefits/index`).fetch();
      return { partner };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).partner, this.$route.path);
  },
});
</script>

<template>
  <section class="partners-container">
    <component
      :is="component.name"
      v-for="(component, index) in partner.components"
      :key="component.name + index"
      :data="component.data"
    />
    <SlpContainer variant="gradient">
      <NextStep :variant="3" />
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.partners-container {
  overflow-x: hidden;
  overflow-y: show;
}
</style>
